<?PHP
sapp_include_once('common.php');

function form_handler() {

	$valid_required = true;
	$valid_optional = true;
        
	$valid = true;

	// check ssl

	    $ssl = sapp_get_submit_value('ssl');
    switch ($ssl) {
        case 'true':
            sapp_set_ssl(true);
            sapp_set_param('ssl','https');
            break;

        default:
            sapp_set_ssl(false);
            sapp_set_param('ssl','http');
            break;
    }


	// check install_prefix

	    $install_prefix = sapp_get_submit_value('install_prefix');

    if (in_array($install_prefix, array(".", "/", "./")))
    {
        $ret = (function_exists('sapp_check_install_prefix'))? sapp_check_install_prefix(SITEAPP_PREFIX_ROOT) : false;
        if (false === $ret || !in_array($ret, array(SITEAPP_DIR_NOT_EXISTS, SITEAPP_DIR_USED_BY_UNKNOWN)))
        {
            sapp_set_wrong('install_prefix', msg('install_prefix__invalid_name'));
            $valid = false;
        }
    }

    switch (sapp_set_install_prefix($install_prefix)) {

        case SITEAPP_DIR_NOT_EXISTS:
            break;

        case SITEAPP_DIR_USED_BY_UNKNOWN:
            sapp_set_wrong('install_prefix', msg('install_prefix__already_exists'));
            $valid = false;
            break;			

        case SITEAPP_DIR_INVALID_NAME:
            sapp_set_wrong('install_prefix', msg('install_prefix__invalid_name'));
            $valid = false;
            break;

        case SITEAPP_DIR_USED_BY_SITEAPP:
            sapp_set_wrong('install_prefix', msg('install_prefix__used_by_sapp'));
            $valid = false;
            break;
    }


	if (sapp_is_ssl_avaible())
		$valid_required &= check_and_set_required('ssl');

	$valid_required &= check_and_set_required('bbc_mainsite',		'check_url');
	$valid_required &= check_and_set_required('bbc_titlebar');
	$valid_required &= check_and_set_required('bbc_language');
	$valid_required &= check_and_set_required('bbc_maxtime',		'check_int');
	$valid_required &= check_and_set_required('bbc_maxvisible',		'check_int');
	$valid_required &= check_and_set_required('bbc_maxos',			'check_int');
	$valid_required &= check_and_set_required('bbc_maxbrowser',		'check_int');
	$valid_required &= check_and_set_required('max_extension',		'check_int');
	$valid_required &= check_and_set_required('bbc_maxrobot',		'check_int');
	$valid_required &= check_and_set_required('bbc_maxpage',		'check_int');
	$valid_required &= check_and_set_required('bbc_maxorigin',		'check_int');
	$valid_required &= check_and_set_required('bbc_general_align_style');
	$valid_required &= check_and_set_required('bbc_title_size',		'check_int');
	$valid_required &= check_and_set_required('bbc_subtitle_size',	'check_int');
	$valid_required &= check_and_set_required('bbc_text_size',		'check_int');

	if (!$valid_required)
		sapp_set_warning(msg('not_all_required_parameters_are_correctly_specifyed'));

	/*****************************
	 *
	 *	Optional parameters
	 *
	 *****************************/
	$valid_optional &= check_and_set_optional('bbc_ignoreip');
	$valid_optional &= check_and_set_optional('bbc_stat_field_id');
	$valid_optional &= check_and_set_optional('bbc_stat_field_time');
	$valid_optional &= check_and_set_optional('bbc_stat_field_visits');
	$valid_optional &= check_and_set_optional('bbc_stat_field_ext');
	$valid_optional &= check_and_set_optional('bbc_stat_field_dns');
	$valid_optional &= check_and_set_optional('bbc_stat_field_refer');
	$valid_optional &= check_and_set_optional('bbc_stat_field_os');
	$valid_optional &= check_and_set_optional('bbc_stat_field_browser');
	
	$valid_optional &= check_and_set_optional('bbc_stat_field_ip');
	$valid_optional &= check_and_set_optional('bbc_stat_field_page');
	$valid_optional &= check_and_set_optional('bbc_stat_field_query');

	if (!$valid_optional)
		sapp_set_warning(msg('optional_parameters_are_wrong'));

	if (!$valid || !$valid_required || !$valid_optional) {
		sapp_set_error(msg('some_parameters_are_wrong'));
		// return the current step number
		return 1;
	}

	// set application URL
        $inst_pref = sapp_get_param('install_prefix');
        $start_path = "";
        if(false){
            sapp_set_param('application_url', "cgi-bin/${inst_pref}${start_path}");
        }
        else{
            sapp_set_param('application_url', "${inst_pref}${start_path}");
        }
        return 2;
}
?>